package gamespecific
{
    import flash.events.Event;
    import flash.geom.Point;
    import meyermike.core.BaseGame;
    import gamespecific.scripts.Intro;
    import meyermike.Global;
    import meyermike.InputUtil;
    import meyermike.util.music.Song;

    /**
     * Game-specific overrides of Main
     */
    public class Main extends BaseGame
    {
        /**
         * Preloading has finished! Start the game!
         */
        protected override function PreloadComplete():void
        {
            meyermike.Global.StageWidth = 400;
            meyermike.Global.StageHeight = 400;

            gamespecific.Global.ScreenCenter = new Point( 0.5 * meyermike.Global.StageWidth, 0.5 * meyermike.Global.StageHeight);
            gamespecific.Global.TunnelRadius = 170;

            super.PreloadComplete();

            Physics.Gravity = 3000;
            Physics.MaxFallSpeed = 8000;

            SwitchToScript(new Intro());
        }

        private function ToggleMusic():void
        {
            if (Music.IsPlaying)
            {
                Music.Pause();
            }
            else
            {
                Music.Resume();
            }
        }

        /**
         * override to skip physics for this game
         */
        protected override function Update():void
        {
            mScript.Update();
            Layers.Update(Time.TimeDelta);
            InputUtil.Update();
            mMusicCredits.Update(Time.TimeDelta);
        }
    }
}
