﻿package gamespecific
{
    import flash.display.Bitmap;
    import flash.display.PixelSnapping;
    import meyermike.Util;

    /**
     * a piece of the cave that will be flying at you
     * @author Mike Meyer
     */
    public class Plane extends CaveObject
    {
        [Embed(source='assets/cave_a.png')]
        private static const CaveImageA:Class;
        [Embed(source='assets/cave_b.png')]
        private static const CaveImageB:Class;
        [Embed(source='assets/cave_c.png')]
        private static const CaveImageC:Class;
        [Embed(source='assets/cave_d.png')]
        private static const CaveImageD:Class;

        private static const POSSIBLE_CAVE_IMAGES:Array = [CaveImageA, CaveImageB, CaveImageC, CaveImageD];

        private var mGraphic:Bitmap;

        public override function Init():void
        {
            super.Init();
            CreateGraphics();
        }

        public override function Shutdown():void
        {
            super.Shutdown();
            DestroyGraphics();
        }

        protected function CreateGraphics():void
        {
            if (null == mGraphic)
            {
                var imageClass:Class = Util.RandomOneOf(POSSIBLE_CAVE_IMAGES);
                mGraphic = new imageClass();
                mGraphic.width = meyermike.Global.StageWidth;
                mGraphic.height = meyermike.Global.StageHeight;
                mGraphic.x = -0.5 * mGraphic.width;
                mGraphic.y = -0.5 * mGraphic.height;
                mGraphic.smoothing = false;
                mGraphic.pixelSnapping = PixelSnapping.ALWAYS;
                mGraphic.cacheAsBitmap = false;
                this.addChild(mGraphic);
            }
        }

        protected function DestroyGraphics():void
        {
            this.removeChild(mGraphic);
            mGraphic = null;
        }
    }

}
