package gamespecific.scripts
{
    import gamespecific.Cave;
    import meyermike.Global;
    import meyermike.util.GuiBuilder;
    import meyermike.util.ScriptBuilder;
    import flash.events.Event;
    import flash.geom.Rectangle;
    import meyermike.constants.Colors;
    import meyermike.core.GameInterface;
    import meyermike.script.Script;
    import meyermike.script.Step;
    import meyermike.Util;
    import meyermike.util.music.Song;

    public class Intro extends Script
    {
        private var mCave:Cave;

        /**
         * initial setup
         */
        public override function Begin(game:GameInterface):void
        {
            super.Begin(game);

            var builder:GuiBuilder = new GuiBuilder(
                new Rectangle(0, 0, Global.StageWidth, Global.StageHeight),
                Game.Layers.UiLayer);
            builder.FontColor = Colors.DESAT_YELLOW;
            builder.HighlightColor = Colors.YELLOW;
            builder.FontSize = 48;
            builder.AddTextCentered("Ninja", 0.5, 0.3);
            builder.AddTextCentered("Spelunker", 0.5, 0.4);
            builder.FontSize = 24;
            builder.AddButtonCentered(
                "PLAY!",
                GoToGame,
                0.5,
                0.7);

            mCave = new Cave();
            mCave.Init(this.Game.Layers.PlatformLayer, this.Game.Layers.NpcLayer);
            mCave.RunSpeed = 400;
        }

        /**
         * clean up
         */
        public override function End():void
        {
            super.End();
            Game.Layers.RemoveAll();
            mCave.Shutdown();
        }

        /**
         *
         */
        public override function Update():void
        {
            super.Update();
            mCave.Update(this.Game.Time.TimeDelta);
        }

        /**
         *
         */
        private function GoToGame(e:Event = null):void
        {
            Game.SwitchToScript( new gamespecific.scripts.Game() );
        }
    }
}
