﻿package gamespecific.widget
{
    import flash.geom.ColorTransform;
    import meyermike.constants.Colors;
    import meyermike.core.GameObject;
    import meyermike.Global;

    /**
     * ...
     * @author Mike Meyer
     */
    public class Fader extends GameObject
    {
        private var _timeRemaining:Number = 0.0;
        private var _fadeTime:Number = 0.0;
        private var _fadeIn:Boolean = true;

        private var mGraphicsDrawn:Boolean = false;

        public function get FadeInProgress():Boolean { return (_timeRemaining > 0); }

        public override function Init():void
        {
            super.Init();
            CreateGraphics();

            // start invisible
            alpha = 0;
        }

        protected function CreateGraphics():void
        {
            if (!mGraphicsDrawn)
            {
                mGraphicsDrawn = true;
                graphics.beginFill(Colors.WHITE);
                graphics.drawRect(
                    0,
                    0,
                    Global.StageWidth,
                    Global.StageHeight );
                graphics.endFill();
            }
        }

        public override function Update(elapsedTime:Number):void
        {
            super.Update(elapsedTime);
            _timeRemaining -= elapsedTime;

            if (_timeRemaining > 0.0)
            {
                var t:Number = (_timeRemaining / _fadeTime);
                alpha = _fadeIn ? 1-t : t;
            }
            else
            {
                alpha = _fadeIn ? 1.0 : 0.0;
            }
        }

        /**
         * fade to a solid color.
         */
        public function FadeToColor(duration:Number, color:uint):void
        {
            var colorTransform:ColorTransform = this.transform.colorTransform;
            colorTransform.redMultiplier   = ( (color & 0xFF0000) >> 16) / 255;
            colorTransform.greenMultiplier = ( (color & 0x00FF00) >> 8) / 255;
            colorTransform.blueMultiplier  = ( (color & 0x0000FF) ) / 255;
            this.transform.colorTransform  = colorTransform;

            alpha = 0;
            _timeRemaining = duration;
            _fadeTime = duration;
            _fadeIn = true;
        }

        /**
         * fade back after FadeToColor
         */
        public function FadeBack(duration:Number):void
        {
            alpha = 1;
            _timeRemaining = duration;
            _fadeTime = duration;
            _fadeIn = false;
        }
    }

}
