﻿package meyermike.core
{
    import flash.display.MovieClip;
    import flash.display.Sprite;
    import flash.events.Event;
    import flash.geom.Rectangle;

    /**
     * ...
     * @author Mike Meyer
     */
    public class GameObject extends MovieClip
    {
        public var dx:Number = 0.0;
        public var dy:Number = 0.0;
        public var dr:Number = 0.0;
        protected var mCurBeat:Number;

        /// workaround for Flash rounding to twips
        private var _x:Number = 0.0;
        public override function get x () : Number { return _x; }
        public override function set x (value:Number) : void { _x = value; super.x = value; }

        /// workaround for Flash rounding to twips
        private var _y:Number = 0.0;
        public override function get y () : Number { return _y; }
        public override function set y (value:Number) : void { _y = value; super.y = value; }

        /// so that physics utilities can tell what they need to ignore
        private var mIsPhysicsEnabled:Boolean;
        public function get PhysicsEnabled():Boolean { return mIsPhysicsEnabled; }
        public function set PhysicsEnabled(value:Boolean):void { mIsPhysicsEnabled = value; }

        public function Init():void
        {
            mCurBeat = 0;
            this.x = 0.0;
            this.y = 0.0;
            this.dx = 0.0;
            this.dy = 0.0;
            mIsPhysicsEnabled = true;
        }

        public function Integrate(elapsedTime:Number):void
        {
            this.x += dx * elapsedTime;
            this.y += dy * elapsedTime;
            this.rotation += dr * elapsedTime;
        }


        public function Update(elapsedTime:Number):void
        {
        }

        public function Beat(beat:Number):void
        {
            ++mCurBeat;
        }

        public function OffBeat(beat:Number):void
        {
        }

        public function QuarterBeat(quarterBeat:Number):void
        {
        }

        /**
         * called after all the final positions have been figured
         * just before drawing
         */
        public function PreDraw():void
        {
        }

        /**
         * Get the collision bounds for collision testing
         */
        public function GetCollisionBounds():Rectangle
        {
            return this.getBounds(this.root);
        }

        /**
         * by default a GO never dies
         */
        public function IsAlive():Boolean
        {
            return true;
        }

        public function Shutdown():void
        {
        }

        /**
         * for spherical collision tests
         */
        public function GetCollisionRadius():Number
        {
            return 0.5 * this.width;
        }
    }

}
