﻿package meyermike.script.step
{
    import flash.display.DisplayObject;
    import meyermike.script.Step;
    import meyermike.script.step.animate.AnimationValues;
    import meyermike.Util;

    /**
     *
     * @author Mike Meyer
     */
    public class Animate extends Step
    {
        private var mTarget:DisplayObject;
        private var mDuration:Number;
        private var mCurTime:Number;

        private var mStartValues:AnimationValues;
        private var mEndValues:AnimationValues;

        public function Animate(objectToAnimate:DisplayObject, startValues:Object, endValues:Object, animDuration:Number=1.0)
        {
            mTarget = objectToAnimate;
            mStartValues = AnimationValues.BuildFromObject(startValues);
            mEndValues = AnimationValues.BuildFromObject(endValues);
            mDuration = animDuration;
            mCurTime = 0;
        }

        public override function Execute(timeDelta:Number):Boolean
        {
            mCurTime += timeDelta;

            AnimationValues.AnimateBetween(mTarget, mStartValues, mEndValues, mCurTime, mDuration);

            return (mCurTime >= mDuration);
        }

        /**
         * Go back to the beginning
         */
        public override function Restart():void
        {
            mCurTime = 0;
        }
    }

}
