﻿package meyermike.script.step
{
    import flash.display.Bitmap;
    import meyermike.core.GameObject;
    import meyermike.core.GameObjectHolder;
    import meyermike.script.Step;

    /**
     * Step to create a game object from an image
     * @author Mike Meyer
     */
    public class CreateGameObjectFromBitmap extends Step
    {
        private var mBitmapClass:Class;
        private var mLayer:GameObjectHolder;
        private var mX:Number;
        private var mY:Number;

        public function CreateGameObjectFromBitmap(layer:GameObjectHolder, bitmapClass:Class, centerX:Number, centerY:Number)
        {
            mBitmapClass = bitmapClass;
            mLayer = layer;
            mX = centerX;
            mY = centerY;
        }

        public override function Execute(timeDelta:Number):Boolean
        {
            var go:GameObject = new GameObject();
            var gfx:Bitmap = new mBitmapClass();
            go.addChild(gfx);
            gfx.x = -0.5 * gfx.width;
            gfx.y = -0.5 * gfx.height;
            go.x = mX;
            go.y = mY;
            mLayer.AddPremade(go);

            return true;
        }
    }

}
