﻿package meyermike.widget
{
    import flash.events.Event;
    import flash.events.MouseEvent;
    import flash.media.Sound;
    import flash.media.SoundChannel;
    import meyermike.constants.Colors;

    /**
     * ...
     * @author Mike Meyer
     */
    public class PulsingTextButton extends PulsingText
    {
        import flash.media.Sound;
        import flash.media.SoundChannel;

        /*
        [Embed(source='../../../../assets/syntchbass.mp3')]
        private static var HoverSoundClass:Class;
        private static var HoverSound:Sound;

        [Embed(source='../../../../assets/squaretone.mp3')]
        private static var ClickSoundClass:Class;
        private static var ClickSound:Sound;
        */

        private static var SoundCh:SoundChannel;

        private var mHoverColor:Number = Colors.YELLOW;

        public function PulsingTextButton()
        {
            super();
        }

        public override function Init():void
        {
            super.Init();

            CreateSounds();

            AddMouseEventListeners();
        }

        public function SetHoverColor(color:Number):void
        {
            mHoverColor = color;
        }

        private function CreateSounds():void
        {
            /*if (null == HoverSound)
            {
                HoverSound = new HoverSoundClass();
                ClickSound = new ClickSoundClass();
            }*/
        }

        public override function Shutdown():void
        {
            RemoveMouseEventListeners();
            super.Shutdown();
        }

        private function AddMouseEventListeners():void
        {
            mTextField.addEventListener(MouseEvent.ROLL_OVER, HandleRollOver);
            mTextField.addEventListener(MouseEvent.ROLL_OUT, HandleRollOut);
            mTextField.addEventListener(MouseEvent.MOUSE_UP, HandleMouseUp);

            this.addEventListener(MouseEvent.CLICK, FixFocus);
        }

        private function RemoveMouseEventListeners():void
        {
            mTextField.removeEventListener(MouseEvent.ROLL_OVER, HandleRollOver);
            mTextField.removeEventListener(MouseEvent.ROLL_OUT, HandleRollOut);
            mTextField.removeEventListener(MouseEvent.MOUSE_UP, HandleMouseUp);

            this.removeEventListener(MouseEvent.CLICK, FixFocus);
        }

        private function HandleRollOver(evt:MouseEvent = null):void
        {
            mTextField.SetFontColor(mHoverColor);
            mPulseTextField.SetFontColor(mHoverColor);
            //SoundCh = Sounds.PlaySound(HoverSound, SoundCh);
        }

        private function HandleRollOut(evt:MouseEvent = null):void
        {
            mTextField.SetFontColor(mColor);
            mPulseTextField.SetFontColor(mColor);
        }

        private function HandleMouseUp(evt:MouseEvent = null):void
        {
            //SoundCh = Sounds.PlaySound(ClickSound, SoundCh);
        }

        /**
         * workaround for weird flash issue with inputs after clicking a textfield
         */
        private function FixFocus(e:Event = null):void
        {
            // working around flash issue with clicked textfield making the keyboard not work.
            stage.focus = null;
        }
    }

}
